module Calendar
  class Engine < ::Rails::Engine
    initializer "calendar" do 
      OrbitApp.registration "Calendar", :type => "ModuleApp" do
        module_label "calendar.calendar"
        base_url File.expand_path File.dirname(__FILE__)
        widget_methods ["widget"]
        widget_settings [{"override_category_with"=>"calendar_type","multiselect"=>true,"display_field"=>"title"}]
        taggable "Event"
        # categorizable
        authorizable
        frontend_enabled
        data_count 1..10

        side_bar do
          head_label_i18n 'calendar.calendar', icon_class: "icons-calendar"
          available_for "users"
          active_for_controllers (['admin/calendars','admin/calendar_types'])
          head_link_path "admin_calendars_path"

          context_link 'calendar.calendar',
                                :link_path=>"admin_calendars_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/calendars'=>'index'},
                                :available_for => 'users'
          context_link 'calendar.categories_management',
                                :link_path=>"admin_calendar_types_path" ,
                                :priority=>2,
                                :active_for_action=>{'admin/calendar_types'=>'index'},
                                :available_for => 'managers'
          context_link 'calendar.calendar_setting',
                                :link_path=>"calendar_setting_admin_calendars_path" ,
                                :priority=>3,
                                :active_for_action=>{'admin/calendars'=>'calendar_setting'},
                                :available_for => 'managers'
          context_link 'tags',
                                :link_path=>"admin_module_app_tags_path" ,
                                :link_arg=>"{:module_app_id=>ModuleApp.find_by(:key=>'calendar').id}",
                                :priority=>4,
                                :active_for_action=>{'admin/events'=>'tags'},
                                :active_for_tag => 'Events',
                                :available_for => 'managers'
        end

      end
    end
  end
end